//Baseada em soluo prvia do monitor Cssio Keisuke Yamauchi e solues do Prof. Simo.
//Turma: S71
//Disciplina: Tcnicas de Programao

// Exame de Recuperao / Substituio / 2 Sem 2023 - S71 - TecProg - DAINF/UTFPR

//========================//========================//========================//========================//========================//========================//

#include <iostream>
#include <vector>
using namespace std;
#include <stdlib.h>
#include <windows.h>
#include <math.h>

//funo copiada da Prova B1 para fins de teste
void gotoxy (int x, int y)
{
    HANDLE hConsoleOutput;
    COORD dwCursorPosition;
    cout.flush();

    dwCursorPosition.X = x;
    dwCursorPosition.Y = y;

    hConsoleOutput = GetStdHandle(STD_OUTPUT_HANDLE);

    SetConsoleCursorPosition(hConsoleOutput, dwCursorPosition);
}

//funo feita para fins de teste
void draw(int x, int y, const char c = '.')
{
    gotoxy(x, y);
    cout << c;
}

//========================//========================//========================//========================//========================//========================//
class Ponto
{
protected:
    int x, y;

public:
    Ponto(const int px = -1, const int py = -1): x (abs(px)), y (abs(py)) // considerando apenas positivos...
    { }
    virtual ~Ponto() { }
    virtual void imprime() { draw(x,y,'.'); }
    const int getX() const { return (x); }
    const int getY() const { return (y); }
    //void setX(const int kx) { x = kx; }
    //void setY(const int ky) { y = ky; }
};

class Linha_Ortogonal: public Ponto
{
private:
    int xf, yf;
    bool vert; // Isto permitir fora uma reta ortogonal mesmo com imperfeies com dados de entrada, cf. mtodo imprime abaixo...

public:
    Linha_Ortogonal(const int px = -1, const int py = -1,
                    const int pxf = -1, const int pyf = -1,
                    const bool v = false):
    Ponto(px,py),
    xf(abs(pxf)),
    yf(abs(pyf)),
    vert(v)
    {
        int aux = -1;
        if (v)
        {
            if (x > xf)
            {
                aux = xf;
                xf  = x;
                x   = aux;
            }
        }
        else
        {
            if (y > yf)
            {
                aux = yf;
                yf  = y;
                y   = aux;
            }
        }
    }

    ~Linha_Ortogonal(){}

    void imprime()
    {
        int tamX = 0;
        int tamY = 0;

        tamX = xf-x;
        tamY = yf-y;

        if (false == vert)
        {
            for (int i = 0; i <= tamX; i++)
            {
                draw(x+i, y, '.');
            }
        }
        else
        {
            for (int i = 0; i < tamY; i++)
            {
                draw(x, y+i, '.');
            }
        }
        cout << endl;
        cout << endl;
    }
};

class Quadrado: public Ponto
{
private:
    int t;
    Linha_Ortogonal v1, v2, h1, h2; //verticais e horizontais

public:
    Quadrado(const int px = -1, const int py = -1, const int pt = -1):
    Ponto(px, py), t(pt),
    v1(x  , y  , x  , y+t, true),
    v2(x+t, y  , x+t, y+t, true),
    h1(x  , y  , x+t, y  , false),
    h2(x  , y+t, x+t, y+t, false)
    {
    }

    ~Quadrado(){}

    const int getT() const { return t; }
    void setT(const int pt) { t = pt;  }

    const bool operator==(const Quadrado& q) const
    {
        if ( (q.getT() == t) && ( q.getX() == x ) && ( q.getY() == y ) )
        {
            return true;
        }
        return false;
    }

    void imprime()
    {
        v1.imprime();
        v2.imprime();
        h1.imprime();
        h2.imprime();
    }
};

class VetPontos
{
private:
    vector<Ponto*> vPontos;

public:
    VetPontos():
        vPontos()
    {
        vPontos.clear();
    }

    ~VetPontos()
    {
        vPontos.clear();
    }

    void incluir (Ponto* p)
    {
        if (NULL != p)
        {
            vPontos.push_back(p);
        }
    }

    void percorrer()
    // Aqui h polimosfirmo dado que cada objeto se imprimir conforme seu subtipo,
    // utilizando para tal o recurso de funo virtual.
    {
        vector<Ponto*>::iterator it;
        for (it = vPontos.begin(); it != vPontos.end(); it++)
        {
            (*it)->imprime();
        }
        cout << endl;
    }
};

class Principal
{
private:
    Linha_Ortogonal linha_horizontal , linha_vertical;
    Quadrado q1,q2;
    VetPontos vp;

    static Principal* p;

private:
    Principal():
        linha_horizontal(2, 2, 7, 2, false),
        linha_vertical(1, 1, 6, 9, true),
        q1(5,12,2),
        q2(5,6,2)
    {
        //incluso dos objetos acima na lista vp
        vp.incluir(static_cast<Ponto*>(&linha_horizontal));
        vp.incluir(static_cast<Ponto*>(&linha_vertical));
        vp.incluir(static_cast<Ponto*>(&q1));
        vp.incluir(static_cast<Ponto*>(&q2));
    }

public:

    ~Principal()
    {
    }

    void execute()
    {
        //s para testar a sobrecarga de operadores
        if(q1.operator==(q2))
        {
            cout << "So quadrados coincidentes" << endl;
        }
        else
        {
            cout << "No so quadrados iguais" << endl;
        }
        system("pause");
        system("cls");
        //objetivo principal da execute()
        vp.percorrer();
    }

    static Principal* getInstance()
    {
        if (NULL == p) { p = new Principal(); }
        return p;
    }
};

Principal* Principal::p = NULL;

int main()
{
    Principal* p = NULL;
    p = Principal::getInstance();
    if (p) p->execute();
    system("pause");
    if (p) delete(p);
    return 0;
}

// No cdigo acima, na funo main e graas  classe Principal tal qual ali programada, h o padro de projeto chamado Singleton...
// Padro de projetos servem para reaproveitamento de solues conhecidas no mbito da orientao objetos para situaes recorrentes.
// Exemplos de padres de projeto, alm do Singleton, h tantos outros como Observer, Mediator, Iterator, Template Method e Builder.
